Einleitung

Die Rente kam, der Zugriff auf das gewohnte CAD-Programm ging verloren, der 3D-Drucker stand still, also musste ein neues Programm her. FreeCAD sollte es werden, weil es mächtig ist und von einer Community erstellt wird. Dass es einsteigerunfreundlich sein sollte, störte mich nicht, ich habe ja Erfahrung und Zeit, aber als ganz falsch erwies sich das Vorurteil nicht. Sei's drum …
Da ich sowieso alles aufschreiben muss, habe ich es gleich in HTML gemacht - vielleicht hilft es jemandem.

Ein Inhaltsverzeichnis dieser Seite und Links zu meinen anderen FreeCAD-Seiten finden Sie in der gelben Spalte rechts (breite Monitore) bzw. oben (schmale Monitore)

  • Dieser Text wurde mit FC0.19 begonnen und wird gerade mit FC0.21 und Ausblick auf FC0.22 überarbeitet.
  • Links zu Videos und Tutorien befinden sich unten auf dieser Seite.
  • Letzte Bearbeitung: 01/2024
URL dieser Webseite
Abb.00b URL

Tipp: Wer am Bildschirm ungestört mit FreeCAD arbeiten möchte, kann diesen Text auf einem Smartphone lesen. (Webadresse  → Abb.00b URL)

Begriffsgruppen: Die deutschen Begriffe in FreeCAD sind nicht immer verständlich oder einheitlich und können sich von Version zu Version ändern. Um die Wahrscheinlichkeit zu erhöhen, dass sich mein Text, Ihr Verständnis und die Begriffe von FreeCAD überschneiden, verwende ich mehrere Begriffe in eckigen Klammern.

  • Beispiel: Kantenabschrägung [Fase, Chamfer].
  • Details:  → Begriffsdiskussion (interner Link)

FreeCAD installieren

  • Stabile Version FreeCAD herunterladen
  • Paket entpacken und auf c:\Program Files\FreeCAD (Beispiel!) kopieren
  • C:\Program Files\FreeCAD 0.22\bin\FreeCAD.exe (Beispiel!) starten

Projekte mit Anleitung

Kapitel überspringen

In diesem Kapitel finden Sie einige Projekte mit mehr oder weniger ausführlichen Anleitungen zum Nachmachen. Blutige Anfänger fangen am besten mit dem Tubenwickler an.

Tubenwickler für den 3D-Druck

Foto des Tubenwicklers
Der Tubenwickler

Die Senftube wird nicht richtig leer? Vom vielen Quetschen bekommt die Tube Risse? Hier hilft der Tubenwickler.

Übersicht
  • Tutorium: Für Anfänger gedacht
    Schwerpunkte:
    • Skizzieren im Arbeitsbereich Sketcher (sehr ausführlich)
    • Extrudieren im Arbeitsbereich PartDesign
    • Radien und Fasen in der 2D-Skizze und im 3D-Modell
    • STL-Export für den 3D-Druck
    • Verwaltung der Maße in Tabellen [Spreadsheet]
    • Technische Zeichnung mit TechDraw [halb fertig]
  • 3D-Druck: problemlos, ca. 3 cm³ Volumen, Material beliebig
  • Interner Link: Tubenwickler
  • Umfang: Tutorium, FCStd-Datei, STL-Datei, PDF der technischen Zeichnung

Dreieck für Poolbillard [Pool Rack] für den 3D-Druck

Bild eines Dreiecks für Poolbillard
Billard-Dreieck für den 3D-Druck
aus drei Einzelteilen
für 3D-Druck und Schrauben M3

Der gebrauchte Poolbillard-Tisch steht endlich im Keller, aber das Dreieck [Pool Rack] für die Kugeln fehlt? Das Dreieck von Thingiverse.com passt nicht auf den 3D-Drucker? Da hilft nur eine Eigenkonstruktion aus kleineren Teilen.

Übersicht
  • Tutorium: Für Einsteiger, die mit dem Sketcher klarkommen
  • Arbeitsbereiche: PartDesign, Sketcher
    Schwerpunkte:
    • Sweeping [Additive Pipe]: Erzeugen eines 3D-Modells mit Profilskizze und Pfad
    • Arbeiten mit Bezugs- und Skizzenebenen zur Vermeidung des topologischen Benennungsproblems
    • Pseudo-Montage in PartDesign zu Präsentationszwecken
  • 3D-Druck:
    • problemlos
    • Material beliebig
    • ca. 3 x 30 cm³ Volumen
    • Grundfläche ca. 120x170 mm²
  • Interner Link: Pool Rack
  • Umfang: Tutorium, FCStd-Datei, STL-Datei

Namensschild

Bild eines Namensschildes
Ein Namensschild

Der Briefkasten braucht ein Namensschild? 3D-Druckteile müssen gekennzeichnet sein? Schlüsselanhänger? Dann muss man Texte auf eine Oberfläche prägen können.

Übersicht
  • Tutorium: Für Einsteiger
  • Arbeitsbereiche: Draft, PartDesign
    Schwerpunkte:
    • Erstellen eines Schriftzuges [ShapeString] in Draft
    • Einbinden des ShapeString in PartDesign mit und ohne ShapeBinder
    • Positionieren des ShapeBinders auf einer Fläche
    • Hinweise zum zweifarbigen 3D-Druck mit einfarbigen Druckern
    • Eigenschaften von Schriftzeichenkontur [Textkontur, Shape String Property]
  • Interner Link: Namensschild
  • Umfang: Tutorium, FCStd-Datei
Links

Fliegenklatsche

Screenshot der Fliegenklatsche
Die Fliegenklatsche aus Blatt, Verbinder und Griff

Die Fliegenklatsche ist eine schöne Fingerübung für FreeCAD und 3D-Druck.

Übersicht
  • Schwierigkeit: Für Einsteiger, die mit dem Sketcher klarkommen.
  • Arbeitsbereiche: PartDesign, Sketcher
  • Schwerpunkte:
    • Wabenmuster mit Mehrfachtransformation
    • umlaufender Rand und Griff mit Sweeping [Additive Pipe]
    • Fasen in der Skizze mit einschränkungserhaltender Verrundung
    • 3D-Druck
  • Interner Link: Fliegenklatsche
  • Umfang: Tutorium, FCStd-Datei, STL-Datei

Stabile parametrische Konstruktionen

Screenshot Klotz mit Bezugsebene
Abb.01c: Klotz mit Bezugsebene (gelb)
Achsen: X (rot) - Y (grün) - Z (blau)
  • Schwierigkeit: Für Einsteiger mit Ambitionen.
  • Arbeitsbereiche: PartDesign, Sketcher, Spreadsheet
  • Interner Link: → Anleitung zu stabilen stabilen Konstruktionen mit FreeCAD
    Schwerpunkte:
    • Maße in Tabellen listen und zu Parametern machen machen (→ Kap.2.1)
    • Mit Parametern aus Tabellen alles mögliche bemaßen (→ Kap.2.2.1)
    • Mit Parametern aus Tabellen in Eingabefeldern rechnen (→ Kap.2.2.2)
    • Mit Parametern in Tabellen rechnen (→ Kap.2.2.3)
    • Maße in Skizzen zu Parametern machen machen (→ Kap.3.1)
    • Mit Parametern aus Skizzen alles mögliche bemaßen (→ Kap.3.2.1)
    • Mit Parametern aus Skizzen in Eingabefeldern rechnen (→ Kap.3.2.2)
    • Mit Parametern in Skizzen rechnen [grafische Löungen, Referenzmaße] (→ Kap.3.2.3)
    • Formel-Editor [Ausdruck-Editor, Expressions] (→ Anhang 2)
  • Umfang: Tutorium, FCStd-Datei, STL-Datei

Datei-Operationen in FreeCAD - Aus 2 mach 1

Screenshot der Baumansicht
2 Kästen in 2 Dateien mit 2 Tabellen

Ziel dieses Tutoriums ist es, zwei ähnliche Dateien mit zwei ähnlichen Tabellen [Spreadsheet] zu einer Datei mit einer Tabelle zusammenzufassen. Das Werkzeug dazu ist nicht FreeCAD, sondern ein Texteditor.

Übersicht
  • Tutorium: Für Nerds
    Schwerpunkt: Operationen im Inneren einer FCStd-Datei mit einem Text-Editor
  • Interner Link: Datei-Operationen
  • Umfang: Tutorium, FCStd-Datei

Projekte in der Pipeline

  • Schachtel (Sweeping)
  • Bleistiftspitzer (Baugruppe)
  • Schraubhülsen (druckbare Gewinde, parametrische Konstruktion mit Spreadsheet)

Anleitungen an anderer Stelle

Hier finden Sie Links zu Tutorien [Schritt-für-Schritt-Anleitungen].

Benutzeroberfläche und wichtige Begriffe

--- Dieses Kapitel ist noch Baustelle ---  →  Kapitel überspringen

Die Menüleiste entspricht den üblichen Standards. Hervorzuheben sind:

  • Edit - Icon EinstellungenPreferences - Preferences - General - Change language: Deutsch - Apply
  • Bearbeiten - Icon Einstellungen Einstellungen [Voreinstellungseditor, Preferences] …
    • … Anzeige - Farben - Hintergrundfarbe - Einfache Farbe
    • … Anzeige - 3D-Viewer - Achsenkreuz
  • Ansicht - … 
    • … Arbeitsbereiche (→Abb.02b)
    • … Symbolleisten
    • … Paneele
    • … Standardansichten - Axonometrisch - Dimetrisch
  • Sketcher [Skizze] - …
    • … Anzeige - Zeige Namen der maßlichen Einschränkung formatiert: %N = %V : ein

2. Symbolleisten

Auch die Symbolleisten entsprechen den üblichen Standards. Hervorzuheben sind:

  • Icon Std_ViewFitAll Alles einpassen [ViewFitAll]
    zaubert Ansichten zurück, die aus der Grafikansicht verschwunden sind.
  • Arbeitsbereich auswählen:
    Screenshot des Auswahl an Arbeitsbereichen
    Abb.02b Auswahl an
    Arbeitsbereichen
    Arbeitsbereiche ist ein wichtiges Konzept von FreeCAD, da sollte man die Arbeitsbereiche schon finden ;-)
  • Standardtastenkürzel ändern: Rechter Mausklick in einen freien Bereich der Symbolleisten - Benutzerdefiniert - … Beispiel …
    … Zum Suchen tippen: dimetrisch - Neue Tastenkombination: 0 - Zuweisen

3. Grafikansicht [Hauptfenster, 3D-Ansicht, 3D-View]

In der Grafikansicht werden Körper bildlich dargestellt, oder auch Skizzen, Tabellen, techn. Zeichnungen usw. Weitere Einstellungen:

  • Farben: Bearbeiten - Einstellungen - Anzeige - Farben
  • Sichtbarbeit des GCS [globales Koordinatensystem]
    → Konzept der Koordinatensysteme
    • CS in Ecke: Bearbeiten - Einstellungen - Anzeige - 3D-Viewer
    • Achsenkreuz: Bearbeiten - Einstellungen - Anzeige - 3D-Viewer
    • Steuerwürfel: Bearbeiten - Einstellungen - Anzeige - Navigation
  • Sichtbarkeit eines Körpers erfordert zwei Schritte:
    • Baumansicht - Körper anklicken - Leertaste
      → schaltet Schrift schwarz/grau
    • Baumansicht - Formelement anklicken - Leertaste
      → schaltet Schrift schwarz/grau
      → Körper wird bis zum Formelement sichtbar ein/aus
      → So kann man den Aufbau eines Körpers Schritt für Schritt prüfen.
  • FreeCAD-Wiki: → 3D-Ansicht

4. Combo-Ansicht, [Combo View]

Die Combo-Ansicht besteht aus mehreren Abschnitten

Hinweis: In Version FreeCAD0.22.0dev fehlt der Begriff Combo-Ansicht. Möglicherweise entfällt er.

Baumansicht, [Modellbaum, Tree View]

Der Begriff Baumansicht ist ein gebäuchlicher Ausdruck für den Bereich Combo-Ansicht - Modell ( →  Abb01b, oben links). Dort wird der Aufbau der Datei als Baumdiagramm dargestellt.

Die Bezeichnungen in der Baumansicht (  → Abb.01b: Körper, Pad, Sketch) wurden von FreeCAD vergeben. Man kann sie im Kontextmenu (=rechter Mausklick) umbenennen. Nur die Datei selbst erhält ihren Namen durch Abspeichern.

Elemente der Baumansicht im Einzelnen

Screenshot Baumansicht und SketchProperty
Abb.01b Baumansicht
und Eigenschaften von Sketch001
  • Unnamed:
    • … ist der Name der ungespeicherten FreeCAD-Datei.
    • Umbenennen:
      Datei - Speichern unter: Dateinamen eingeben
  • Spreadsheet [Tabelle]:
    • … ist nicht notwendig, aber ein Beispiel dafür, dass eine FreeCAD-Datei mehr als Bauteile enthalten kann.
  • Körper [Bauteil, Einzelteil, 3D-Modell, Body]:
    • Körper steht im Arbeitsbereich PartDesign für ein einzelnes Bauteil.
    • Formelemente nenne ich die Elemente, die eine Ebene unter Körper00x liegen. Formelemente entsprechen den Arbeitsschritten, die zum vollständigen Körper führen.
    • Die Schrift ist grau und deshalb ist der Körper in der Grafikansicht  →  nicht sichtbar.
  • Körper001 [Body]:
    • … ist das zweite Bauteil innerhalb der FreeCAD-Datei ( →  Abb01a: Quader mit Hohlzylinder).
    • Die Schrift ist schwarz und deshalb kann der Körper  →  sichtbar sein.
    • Die Schrift ist fett und hinterlegt und das bedeutet, dass Körper001  →  aktiviert ist und bearbeitet werden kann.
  • Origin001 [Koordinatensystem]
    • … enthält das Koordinatensystem von Körper001
    • Im Aufklappmenü unter Origin findet man die Hauptachsen X, Y, Z und die Hauptebenen XY, XZ, YZ des Koordinatensystems.
  • Pad [Extrusion, Aufpolstern, Pad] [Formelement, Volumenelement]:
    • … ist das erste Formelement von Körper001 ( →  Abb.01a Grafikansicht, Quader)
    • Extrusion [Pad] ist ein Werkzeug von PartDesign, mit dem Skizzen in ein Prisma verwandelt werden.
  • Sketch:
    • … ist die Skizze, auf der Pad aufbaut.
  • Revolution [Rotation, Drehen, Drehteil, Revolution]:
    • … ist das zweite Formelement von Körper001 ( →  Abb.01a Grafikansicht, Hohlzylinder)
    • Die Schrift ist schwarz und gemeinsam mit der schrzen Schrift von Körper001 bedeutet dies, dass Körper001 in der Grafikansicht bis zu diesem Formelement sichtbar ist ( →  Abb.01a).
  • Sketch001:
    • … ist die Skizze, auf der Revolution aufbaut.
    • Sketch001 ist grau hinterlegt und das bedeutet, dass ihre  → Eigenschaften sichtbar sind ( →  Abb.01b Eigenschaft).
  • Körper002 [Body]:
    • … ist das dritte Bauteil innerhalb der FreeCAD-Datei.
    • Schrift ist schwarz  →  Sichtbarkeit

Einstellungen in der Baumansicht

Arbeitsposition festlegen

Normalerweise liegt die Arbeitsposition in einem Körper am Ende seines Baumes, d.h., dass neue Skizzen o.ä. am Ende angehängt werden. Mit Arbeitsposition festlegen kann man neue Elemente/Arbeitsschritte auch mitten im Baum eines Körpers einfügen

  • Aufruf im Kontextmenu eines Unterelementes des aktiven Körpers

Aktiver Körper

In einer Sitzung von FreeCAD kann immer nur ein Körper bearbeitet werden. Dieser Körper muss aktiviert sein:

  • Körper im Baumansicht doppelklicken
    • Aktiviert der Körper
    • In der Baumansicht ist der Körper schwarz, fett und hinterlegt
  • Wenn vorher ein Körper aktiviert war, wird dies beendet.

Eigenschaften(-Editor) [Property]

Eigenschaften [Property] ( →  Abb01b) ist eine universelle Methode von FreeCAD, um Parameter [Maße] zu verwalten. Manchmal kann man dieselben Parameter wahlweise in den Eigenschaften oder in der Parameter-Maske bearbeiten, aber nicht für jedes Werkzeug sind beide Methoden verfügbar.
Man findet Eigenschaften unter Combo-Ansicht - Eigenschaft, wenn ein Formelement oder eine Skizze in der Baumansicht markiert ist.

  • Combo-Ansicht - Eigenschaft - Attachment - Attachment: Hier kann man die Position (Winkel und (Dreh-)Achse, Position X, Y, Z) des Elementes ggü. seinem nächsten übergeordneten Element einstellen.
    Beispiel: In  →  Abb01b sind Skizzen-Eigenschaften von Sketch001 gezeigt. Hier kann man Richtung und Position der Skizzenebene einstellen.
  • Combo-Ansicht - Eigenschaft - Basis - Placement: Hier kann man die Position (Winkel und (Dreh-)Achse, Position X, Y, Z) des Elementes ggü. seinem Körper ablesen, aber nicht einstellen.

"Eine Eigenschaft ist eine Information in Form einer Zahl oder einer Zeichenkette, die mit einem FreeCAD-Dokument oder einem Objekt in einem Dokument verbunden ist. Öffentliche Eigenschaften können mit dem Eigenschaftseditor angezeigt und geändert werden. Eigenschaften spielen in FreeCAD eine sehr wichtige Rolle. Objekte in FreeCAD sind "parametrisch", d.h. ihr Verhalten wird durch ihre Eigenschaften festgelegt,…" (FreeCAD-Wiki: Property)

  • Attachment - Support:
    • … hier kann die Stützebene [Support] der Skizze geändert werden.
      intern:  →  --- Beispiel ergänzen ---
  • Attachment - Offset - … und andere Werte in eckigen Klammern werden nur angezeigt, können aber hier nicht geändert werden.
  • Skizzenebene drehen:
    • … - Winkel [Angle ?]: Winkel zwischen Stützebene und Skizzenebene eingeben, hier -15°
    • … - Achse X/Y/Z: Drehachse mit "1" markieren
  • Skizzenebene verschieben:
    • Position X/Y/Z: Versatz in mm eingeben.
  • Entgegen der Reihenfolge der Maske wird erst die Position geändert und danach die Ebene gedreht.
  • Das lokale Koordinatensystem der Skizzenebene habe ich bisher noch nicht verstanden, weil Ausprobieren so schnell geht ;-)

Anwendungsbeispiele:

Parameter(-Maske) [Aufgabenpaneel, Parameter]

Wenn man ein Werkzeug [Formelement] von PartDesign aufruft, erscheint die Maske zum Eingeben von Parametern, die zum Werkzeug passt (Beispiel:  →  Abb.05b). Gelegentlich muss man die Maske verlassen und findet sie danach unter Combo-Ansicht - Aufgaben wieder.

Eine bestehende Parameter-Maske kann man durch Doppelklick auf ein Formelement in der Baumansicht öffnen und die Parameter ändern. Viele der Parameter kann man auch in Property aufrufen.

Python-Konsole

Davon verstehe ich nix.

Konzepte von FreeCAD

→ ---Kapitel Konzepte überspringen ---

Hier stelle ich Arbeitsbereich-übergreifende Konzepte von FreeCAD vor, von denen ich mir gewünscht hätte, dass ich sie von Anfang an gekannt hätte.

---Arbeitsbereich-spezifische Konzepte, Probleme ---

Arbeitsbereiche [Workbench]

Kapitel überspringen

Die Werkzeuge von FreeCAD sind in Arbeitsbereichen [Workbench] organisiert. Jeder Arbeitsbereich ist für einen Aufgabenbereich gedacht und enthält dafür geeigneten Werkzeuge. Manche Arbeitsbereiche konkurrieren und bieten unterschiedliche Lösungen an z.B. (→Part und →PartDesign). Es ist möglich, bei der Bearbeitung einer Konstruktion zwischen den Arbeitsbereichen zu wechseln (→ Auswahlmenu für Arbeitsbereiche).

Arbeitsbereiche finde ich bei FreeCAD besonders spannend. Anscheinend beginnt es oft damit, dass FreeCAD-Nutzer ein spezielles Interesse haben und einen Arbeitsbereich dazu programmieren. Manche davon decken scheinbar exotische Probleme ab, manche verlaufen im Sande, manche werden später ins offizielle FreeCAD integriert und ein jeder kann neue Lösungen bieten.

Auf diesen Seiten gehe ich nur auf die Arbeitsbereiche ein, die ich selbst verwendet habe, und nicht mal alle von diesen konnte ich bisher ausführlich beschreiben.

Links und Hinweise:

Icon des Arbeitsbereiches Part  Arbeitsbereich Part

Der Arbeitsbereich Part baut 3D-Modelle im Wesentlichen aus einfachen geometrischen 3D-Formen auf (Quader, Zylinder, Kegel, …) und verknüpft sie durch boolesche Operationen.

Da der Arbeitsbereich PartDesign ebenfalls 3D-Modelle erstellt und ich mit dessen Denkweise vertraut bin, habe ich mich auf PartDesign konzentriert und kenne mich mit Part nicht aus.

Links und Hinweise:

Icon des Arbeitsbereiches PartDesign  Arbeitsbereich PartDesign [3D-Modelle]

… gemeinsam mit …

Icon des Arbeitsbereiches Sketcher  Arbeitsbereich Sketcher [2D-Skizzen]

Screenshot Hammerkopf
Abb.06. Hammerkopf mit
Skizze für das Stielloch

Die Arbeitsbereiche PartDesign und Sketcher sind eng miteinander verknüpft. Sketcher erzeugt die (2D-)Skizzen, die PartDesign zu (3D-)Formelementen modelliert. Schrittweises Auf- und Abtragen lässt so einen Körper [Bauteil, Body] entstehen, ähnlich wie in einer realen Fertigung ( → Abb.06).

Da ich vornehmlich mit Sketcher und PartDesign arbeite, sind meine Notizen dazu so umfangreich geworden, dass ich sie ausgelagert habe:

Links und Hinweise:

Icon des Arbeitsbereiches Spreadsheet  Arbeitsbereich Spreadsheet

Screenshot Maßtabelle beim Tubenwickler
Beginn der Maßtabelle beim Tubenwickler

Im Arbeitsbereich Spreadsheet [Tabellenblatt] kann man Maße übersichtlich auflisten und in Skizzen oder Modelle einer FreeCAD-Konstruktion übernehmen. Das Verfahren erleichtert das Ändern von Maßen, z.B. in der Entwicklungsphase oder für Baureihen in verschiedenen Größen. Praktisch ist, dass das CAD-Modell und die Tabelle in einer Datei gespeichert werden.

Links und Hinweise:

Icon des Arbeitsbereiches TechDraw  Arbeitsbereich TechDraw [Technische Zeichnungen]

Screenshot Ansichten des Tubenwicklers
Ansichten des Tubenwicklers

Im Arbeitsbereich TechDraw erstellt man technische Zeichnungen aus 3D-Modellen, die man vorher in anderen Arbeitsbereichen erstellt hat, z.B. in PartDesign. Praktisch ist, dass das CAD-Modell und die technische Zeichnung in einer Datei gespeichert werden.

Links und Hinweise:

Icon des Arbeitsbereiches A2plus  Arbeitsbereich A2plus [Baugruppen]

Der Arbeitsbereich A2plus ist ein Werkzeug zum Erstellen von Baugruppen aus Einzelteilen. Man öffnet eine Baugruppen-Datei, importiert Einzelteile und verbindet Sie mit Einschränkungen.

A2plus ist ein inoffizielles Addon von kbwbe und muss nachträglich zu FreeCAD installiert werden. Wie das funktioniert, finden Sie am  → Anfang dieses Kapitels Arbeitsbereiche. Bevor Sie A2plus installieren, sollten Sie sich über die Alternativen Assembly3 und Assembly4 informieren ( → Liste der externen Arbeitsbereiche.

Links und Hinweise:
  • intern:  → ---Tutorium Spitzer - Baugruppe (geplant)---
  • intern:  → ---Arbeitsbereich A2plus (geplant)---
  • FreeCAD-Wiki: → Arbeitsbereich A2plus

Koordinatensysteme [Coordinate Sytem CS]

Kapitel überspringen

Screenshot einer Dolde mit Koordinatensystemen
Abb.22a Dolde mit
mehreren CS

Eine FreeCAD-Datei verwendet kein einzelnes Koordinatensystem [CS], sondern ganze Kaskaden davon (→Abb.22a).

Es gibt viele Gründe, einen Körper, eine Bezugsebene oder ein Skizzenblatt zu verschieben oder zu verdrehen. Aber für diese Elemente gilt dann nicht mehr das globale CS der Datei, das in der Grafikansicht standardmäßig angezeigt wird.

Jede CS-Kaskade startet am globalen CS der Datei [GCS] (→Abb.22b).

Lokale Koordinatensysteme [LCS]: Viele Elemente einer Datei (=Körper, Bezugsebene, Skizze …) erhalten ein eigenes LCS, das beim Erstellen des Elementes am übergeordneten CS verankert wird und anschließend positioniert werden kann (→Abb.22c-f).

Verankerung: Ein Körper [Body] hat nur die Datei über sich, also übernimmt sie das GCS automatisch.
Für alle anderen LCS muss man eine Stützebene (Hauptebene des Körpers, Bezugsebene …) auswählen. Die Stützebene [Support] wird immer zur xy-Ebene des neuen LCS, seine z-Achse steht senkrecht zu ihr.

Positionieren: Anschließend kann man das neue LCS in Richtung seiner ursprünglichen Koordinaten verschieben oder verdrehen. Dies kann immer in der Parameter-Maske geschehen, manchmal zusätzlich an anderen Stellen.

Alle Koordinatensysteme sind kartesisch. Um die LCS unterscheiden zu können, habe ich ihnen eigene Namen gegeben. Im Sinne der Übersichtlickeit sind nicht alle Methoden aufgeführt.

Die Abstufung der Koordinatensysteme CS im Einzelnen:

  1. CS der Datei (Global CS, GCS]
    Screenshot eines globalen Koordinatensystemens
    Abb.22b globales
    Koordinatensystem GCS
    • Das GCS ist unveränderlich vorgegeben.
    • Das GCS kann man im Grafikfenster als Steuerwürfel [NavigationCube], Achsenkreuz oder Koordinatensystem in Ecke sichtbar machen (→ Abb.22b).
    • Nur das Achsenkreuz steht im Zentrum des GCS.
    • CS sichtbar machen:
  2. CS eines Körpers [Body CS, BCS, Origin]
    Screenshot des CS eines Körpers
    Abb.22c CS eines Körpers
    [Origin]
    • Ein Körper übernimmt zunächst das GCS → Origin.
    • Origin enthält die Hauptachsen (X, Y, Z) und Hauptebenen (XY, XZ, YZ)(→ Abb.22c)
    • CS sichtbar machen:
      • → Baumansicht - axis/plane markieren - Leertaste
    • Positionieren (hier in Basis, sonst in Attachment):
      • → Basis - Placement - hier: Position Y: +100 mm
      • → Baumansicht - Körper (Kontextmenu) - Transformieren
      • → Baumansicht - Körper (Kontextmenu) - Positionieren

  3. CS eines Bezugswerkzeuges [DatumTool CS, DCS] (optional)

    PartDesign DatumPlane Bezugsebenen und PartDesign CoordinateSystem Bezugskoordinatensysteme sind Hilfsmittel, um Skizzen abseits des CS des Körpers [Origin] zu positionieren. In komplizierten Fällen kann man sie kaskadieren, in einfachen Fällen benötigt man sie gar nicht, denn auch Skizzen können im CS positioniert werden.
  1. a.) CS eines PartDesign CoordinateSystem  Bezugskoordinatensystems [Lokales Koordnatensystem, CoordinateSystem, Local_CS]

    Ein Bezugkoordinatensystem [Local CS] soll helfen, die Dolde an der Spitze des Stammes zu modellieren. Eine Bezugsebene würde auch genügen, aber die wird nicht so schön angezeigt ;-)
    Screenshot eines lokalen CS
    Abb.22d Local_CS
    in einem Körper
    • Formelement Stamm um die z-Achse des Origin.
    • Stützebene [Support]: XY-Ebene (des Origin)
      = wird zur xy-Ebene des Local-CS
    • CS sichtbar machen:
      • → Baumansicht - Local_CS markieren - Leertaste
    • Positionieren (hier: an die Spitze des Stammes):
      • Attachment - Support/Winkel/Position
      • → Baumansicht - Doppelklick auf Local_CS - Aufgaben
      • → Baumansicht - Local_CS (Kontextmenu) - Positionieren
    • Basis - Placement (nicht veränderbar):
      • Gibt die Position relativ zum Origin an.
      • Stimmt hier mit Attachment überein, da Local_CS an die XY-Plane des Origin gebunden ist.
    • Nacharbeiten: Local_CS bringen keine (Neben-)Achsen und (-)Ebenen mit und sind deshalb alleine nicht nutzbar. Aber wenn man sie mit Bezugslinien und -Ebenen nachrüstet, werden sie fast so komfortabel wie Origin.
  1. b.) CS einer PartDesign DatumPlane Bezugsebene [DatumPlane]

    Local_CS sind alleine nicht nutzbar, deshalb ergänzen wir je eine Bezugs-Achse und -Ebene.
    Hinweis: Die Dolde ist so einfach, dass man kein Local_CS benötigen würde. Aber für Bezugsebenen kann man kein Achsenkreuz anzeigen lassen und müsste die Achsen teilweise raten.
    Screenshot einer Bezugsebene in einem lokalen CS
    Abb.22e Bezugsebene (grün)
    als Ebene eines Local_CS
    -- Winkel passt nicht zu Abb.22e---
    • Die Stützebene für die Bezugsebene ist hier auf zwei Parameter verteilt:
      Attachment - Support: Local_CS (Ast_CS)
      Attachment - Map Mode: ObjectYZ
      → yz-Ebene des Local_CS wird zur xy-Ebene der Bezugsebene
    • Bezugsebene sichtbar machen:
      • → Baumansicht - DatumPlane [Bezugsebene] markieren - Leertaste
    • Positionieren am Fuß des Astes:
      • Attachment - Support/Map Mode/Winkel/Position
      • → Baumansicht - Doppelklick auf Local_CS - Aufgaben
      • → Baumansicht - Local_CS (Kontextmenu) - Positionieren
    • Basis - Placement (nicht veränderbar):
      • Gibt die Position der Bezugsebene relativ zum Origin an.
      • Der seltsame Winkel ist Folge der CS-Kaskade.
    • Size (veränderbar):
      • Gibt an, wie groß die Bezugsebene in der Grafikansicht dargestellt wird.
    • Bezugslinie [DatumLine] sinngemäß an die X-Achse des Local_CS (Ast_CS) binden.
    • Fehlt nur noch eine Skizze…
       
  2. CS eines Skizzenblattes (Sketch CS, SCS)

    Hinsichtlich der Verankerung und der Sichtbarkeit funktionieren Skizzenblätter weitgehend wie Bezugsebenen [DatumPlane], deshalb kann man in einfachen Fällen auf Bezugsebenen verzichten. Skizzenebenen oder ihr CS werden nicht angezeigt, aber eine Skizze selbst, hier: Blatt (grün).
    Screenshot einer Skizze in einem lokalen CS
    Abb.22f Skizze eines Blattes (grün)
    basierend auf Bezugsebene
    im Local_CS
    • Formelement Ast um die X-Achse von Ast_CS [Local_CS], realisiert durch Ast_CS_X [DatumLine]
    • Stützebene [Support]: DatumPlane (Ast_CS_YZ)
      • wird zur xy-Ebene von Sketch002
    • Skizze sichtbar machen:
      • → Baumansicht - Sketch002 markieren - Leertaste
    • Positionieren an die Spitze des Astes:
      • Attachment - Support/Winkel/Position
      • → Baumansicht - Local_CS [Ast_CS] (Kontextmenu) - Anhangeditor
    • Basis - Placement (nicht veränderbar):
      • Gibt die Position von Sketch002 Bezugsebene relativ zum Origin an.
    • Sketch - Constraints (veränderbar):
      • Enthält die Maße der Skizze.
    • Fehlen nur noch ein paar polare Muster zu → Abb.22a
Links und Hinweise

Randbedingungen / Freiheitsgrade>

Kapitel überspringen

Dieses Kapitel wurde verlegt zur Seite AB Sketcher

parametrisch / Parameter

Kapitel überspringen

--- visualisieren ---

"FreeCAD - Ihr parametrischer 3D-Modellierer" wirbt die Homepage von FreeCAD. Was bedeutet das eigentlich? Keine Ahnung, dafür ist der Begriff "Parameter" zu vieldeutig (→ Wikipedia - Parameter). Klingt aber gut …

Trotzdem lohnt es sich, zu überlegen, welche Bedeutungen der Begriff Parameter haben kann, dann lernt man auch Fähigkeiten von FreeCAD.

  1. Parameter als Maß
    • In der einfachsten Version ist Parameter ein hochtrabender Begriff für Maß, Menge usw.
    • Eingabefelder: Maße usw. kann man überall eintragen, wo man sie eben braucht, also in Skizzen, Parameter-Masken, Eigenschaften-Editor und - im Moment sinnlos - in Tabellen [Spreadsheet]
    • Funfact: Parameter oder Eigenschaften oder Maße - alles ziemlich das Gleiche …
    • Noch ist ein Parameter nix besonderes …
  2. Parameter mit Namen
    • In FreeCAD kann man für Parameter einen Parameternamen vergeben, natürlich unter verschiedenen Begriffen - Gruß aus Babylon:
      Parameternamen heißen …
      • In Skizzen: Namen (optional)
      • In Tabellen: Alias
      • In Parameter-Masken sind feststehende Begriffe vergeben
    • Doch was fängt man mit den Parameternamen an?
  3. Parameternamen statt Maße in Eingabefelder eingeben
    • In Eingabefelder kann man nicht nur Parameter (Maße), sondern auch Parameternamen (Maße von woanders) eingeben. Natürlich gehört eine Adresse dazu, damit FreeCAD "woanders" findet.
    • Damit sind Maße mit Parameternamen übertragbar und Konstruktionselemente können miteinander verkoppelt werden.
  4. parametrisch modellieren
    • Parametrisch modellieren heißt also: Ändert sich hier etwas etwas, passt sich dort etwas passen an.
    • Beispiel: Wird ein Rohrdurchmesser geändert, passt sich der Flansch an.
  5. Parameter in Tabellen [Spreadsheet]
    • Genial finde ich, dass FreeCAD eine integrierte Tabellenkalkulation hat.
    • Dort kann man Parameter übersichtlich tabellieren, umrechnen und in die Konstruktion übertragen.
    • Inzwischen ist parametrische Bemaßung eine ferngesteuerte Bemaßung.
  6. Zugabe: Formeleditor [Ausdruck-Editor, Expressions]
    • Nicht nur in den Tabellen, sondern in jedem Eingabefeld kann man einen Icon des Formeleditors Formeleditor aufrufen. Dort kann man Zahlen, Maßen und Parameternamen eingeben und mit ihnen rechnen lassen, das Ergebnis fließt in die Konstruktion ein oder wird ein neuer Parameter.
    • Beispiel: Man kann einen Außendurchmesser mit 1,2 * Innendurchmesser bemaßen.
    • Besonders Genial finde ich, dass der Formeleditor von FreeCAD mit Einheiten rechnen kann. Praktisch nutze ich es selten, denn wenn man einmal mm eingegeben hat, muss man es immer tun, und das wird lästig. Ich bin halt doch ein schwacher Mensch …
    • FreeCAD-Wiki:  →  Formeln [Ausdrücke, Expressions]
  7. Disclaimer
    • Man könnte sich viel Zahlengedöns sparen, wenn man statt Maße zu übernehmen bestehende Formelemente referenziert.
    • Beispiel: Fläche anklicken, Skizze draufsetzen, Kreis zeichnen, bohren, fertig …
    • Sollte "Ihr parametrischer 3D-Modellierer" auf diese Möglichkeit anspielen, hielte ich es für eine Mogelpackung, solange es das → TNP gibt.
Links und Hinweise

--- öffentliche und interne Parameter ---

--- Reste, einarbeiten ---:

Parametrische Bemaßung

Verschoben nach  → Parametrische Bemaßung

Screenshot Klötzchen mit Bezugsebene
Abb.11a Bezugsebene auf Schräge

Parametrische Bemaßung ist sozusagen eine ferngesteuerte Bemaßung: Ändert sich hier etwas etwas, muss sich dort etwas anpassen.

Am Beispiel einer Bezugsebene auf einer Schräge werden hier verschiedene Methoden der parametrischen Bemaßung gezeigt. D.h.: Wenn die Schräge durch Konstruktionsänderungen verschoben wird, folgt die Bezugsebene automatisch ( → Abb.11a).

Es enthält die Kapitel

  • Ist jedes Maß ein Parameter …?
  • Bezugsebene direkt an die Schräge binden
  • Maße zu Parametern machen und in verwenden
  • Formeleditor
  • Referenzmaße: Grafische Lösung statt Formeln
  • Parameter in Tabellen verwalten

Blick ins Innere von Körpern

Manchmal möchte man in das Innere eines Körpers schauen, z.B. wenn eine Skizzenebene im Körper liegt oder der Körper eine Innenkontur besitzt. Hier werden Möglichkeiten gezeigt, die (Durch-)Sichtbarkeit von Elementen zu beeinflussen.

Die Abbildungen stammen vom  → Tubenwickler

Sichtbarkeit von Elementen ein- oder ausschalten

Screenshot Sichtbarkeit
Abb.23a Sichtbarkeit ein/aus:
Leertaste drücken
  • Arbeitsbereich: beliebig
  • Baumansicht - Element (markieren, hier: Pad) - Leertaste drücken
     → Sichtbarkeit des Elementes wird ein- bzw. ausgeschaltet
  • Details:
    • Elemente werden sichtbar, wenn auch der Körper [Body] sichtbar geschaltet [schwarz dargestellt] ist.
    • Formelemente, hier z.B. Pad, werden nicht einzeln sichtbar, sondern immer der Körper [Body] bis einschließlich zum gewählten Formelement.
    • Bezugselemente, z.B. Bezugsebenen, werden einzeln sichtbar.

Bis zur Skizzenebene aufschneiden

Screenshot ViewSection
Abb.23d Skizzenebene freigelegt
  • Icon des Arbeitsbereiches Sketcher  Arbeitsbereich Sketcher
  • Icon des Arbeitsbereiches SketcherViewSection  Skizze freilegen [Schnittansicht-Modus, Abschnitt anzeigen, Schnitt anzeigen, View Section]
     → Öffnet den Blick bis zur Skizze temporär

Bis zur Skizzenebene aufschneiden kann man ab FC0.20 zur Standardeinstellung machen:

  • Menüleiste - Ansicht - Einstellungen - Sketch - Anzeige - Skizze im Schnittansicht-Modus anzeigen: ein

Drahtgitteranzeige

Screenshot Drahtgitteranzeige
Abb.23c Drahtgitteranzeige des Körpers
mit sichtbarer Skizze
  • Icon des Arbeitsbereiches PartDesign  Arbeitsbereich PartDesign
  • Icon DrawStyle Zeichenstil [Draw Style] -
    Icon DrawStyleWireFrame Drahtgitter [Wire Frame] -
     → Stellt Elemente als Drahtgitter dar

Elemente durchscheinend machen

Screenshot Transparenz
Abb.23b Transparenter Körper
mit sichtbarer Skizze
  • Arbeitsbereich: beliebig
  • Baumansicht - Body (Kontextmenu) - Darstellung - Transparenz: … (% ?)
     → Macht den Körper durchscheinend
  •  → dadurch wird die Skizze sichtbar

In Abb.23b wurde die Skizze (mit roten Punkten) sichtbar gemacht durch:

  • Baumansicht - … - Sketch00x - Leertaste
  • Der drumherum liegende Körper hat Transparenz: 90%

Ansicht - Schnittebene

Beispiel: Mit Abschneiden in Y und Versetzen: 0 wird das Teil oder die Baugruppe an der XZ-Ebene geschnitten dargestellt. Mit Versetzen wird die Ebene in ± Y-Richtung verschoben. Eine benutzerdefinierte Ebene ist möglich, mehrere Schnittebenen können kombiniert werden.

Einschränkung: Eine Skizze, die in derselben Ebene liegt wie die Schnittebene, wird unvollständig dargestellt.

Arbeitstechniken

Radien und Fasen

Radien [Fillet, (Ab-)rundungen, Radius] und Fasen [Chamfer, Abschrägungen] sind typische konstruktive Elemente, um Kanten zu brechen. Dafür gibt es viele Gründe, allen voran der haptische: gerundete oder gefaste Kanten fühlen sich nicht so scharfkantig an.

Normalerweise bringt man Radien und Fasen sowohl in der praktischen Fertigung als auch in CAD als letzten Schritt am 3D-Modell an. FreeCAD bietet dafür im Arbeitsbereich PartDesign die Funktionen Icon des Arbeitsbereiches PartDesign- Fillet und Icon an, aber wie viele Funktionen in PartDesign unterliegen sie dem topologischen Benennungsproblem und sind deshalb nur eingeschränkt nutzbar.

In manchen Fällen gibt es andere Möglichkeiten, um Radien und Fasen zu erzeugen

  1. Oft kann man Radien und Fasen schon in der Skizze erzeugen.
    Bevor alte CADler den Kopf schütteln, weil sie den Mehraufwand kennen, sollten sie weiter lesen:
    • Icon des Arbeitsbereiches Sketcher- einschränkungserhaltende Verrundung
      Sketcher - Einschränkungserhaltende Verrundung
      FreeCAD bietet eine zeitsparende Funktion: Einschränkungserhaltende Verrundung [Constraint-preserving sketch fillet] im Arbeitsbereich Sketcher.
    • Im Prinzip zeichnet und bemaßt man die Skizze vollständig ohne Rundungen, wie man es sonst auch tut. Erst danach bringt man Einschränkungserhaltende Verrundungen an und damit bleiben alle Maße und Einschränkungen erhalten - man muss nur noch die Radien bemaßen.
    • Das funktioniert auch für 45°-Fasen, wenn man den Radius mit einer Linie abkürzt und anschließend den Radius zu einer Konstruktionslinie macht. Sie finden ein ausführlicheres Beispiele in den Tutorien.
  2. Wenn gar nichts geht, muss man in den sauren Apfel beißen und die PartDesign-Funktionen verwenden
  3. Radien und Fasen kann man auch durch Sweepen erzeugen, aber der Aufwand rechnet sich nur, wenn man vorhandene Kanten als Pfad [Leitkurve] übernehmen kann. Hier gehe ich auf das Verfahren nicht ein.

Beim 3D-Druck sind Radien an waagerechten Kanten problematisch, wenn sie auf dem Druckbett aufliegen. Je größer der Radius ist, desto stärker wird nämlich der Überhang, den der Drucker bei der zweiten Schichte bewältigen muss. Deshalb verwende ich Radien bevorzugt an Kanten, die senkrecht gedruckt werden, und Fasen an den waagerechten Kanten. Wenn man die Radien etwas größer macht als die Fasen, hat dies zudem den Vorteil, dass die Fasen den Radien folgen und man nur wenige Fasen benötigt.

--- für mich zu tun: Illustration ---

Arbeitsbereichübergreifende Werkzeuge

Standardansichten

Icon Std_ViewFitAll  Icon Std_ViewFitSelection  Icon Std_ViewIsometric  Icon Std_ViewFront  Icon Std_ViewTop 

Nähere Infos finden Sie im FreeCAD-Wiki Std Menü Ansicht.

Für Anfänger sind vor allem zwei Icons wichtig:

  • Icon Std_ViewFitAll Alles einpassen [ViewFitAll]
    bringt Ansichten zurück, wenn sie aus der Grafikansicht verschwunden sind.
  • Icon DrawStyle Zeichenstil [Draw Style] -
    öffnet den Weg zu einigen Zeichenstilen, mit denen man in das Innere eines Körpers schauen kann, z.B.
    Icon DrawStyleWireFrame Drahtgitteranzeige [Wire Frame]
  • Icon Std_ViewFront Vorderansicht
    schaut auf die XZ-Ebene in y-Richtung, also "von hinten"
  • Icon Std_ViewTop Draufsicht
    schaut auf die XY-Ebene gegen die z-Richtung, also "von oben"
Links und Hinweise

Probleme

Dem Anschein nach verfügt FreeCAD für die grundlegende 3D-Modellierung über die meisten Funktionen, die ich vom Inventor kenne, und einige mehr. Aber bei der gewohnten Vorgehensweise habe ich mit seltsamen Problemen viele Stunden verbraten. Damit meine ich nicht die üblichen Umsteigerprobleme, denen FreeCAD auch nicht gerade entgegenkommt, sondern zusätzlich:

  • Funktionen, Befehle, Fehlermeldungen, Hinweise usw. sind in FreeCAD sehr uneinheitlich bezeichnet.
    Aktualisierung: Etwa ab 2022 habe ich den Eindruck, dass die Bezeichnungen besser werden.
  • Beschreibungen und Dokumentationen sind reichlich vorhanden, aber für mich oft unverständlich.
  • Für den Umstieg haben mir vor allem Videotutorien und Sitzfleisch geholfen.

Die grundlegenden Probleme, auf die ich immer wieder stoße, (Geburtsfehler ?) sind folgende:

Topologisches Benennungsproblem - Topological Naming Problem

FreeCAD bezeichnet intern alle Elemente mit Nummern, z.B. Face1, Face2, Edge1 usw. Bei jeder Änderung der Konstruktion werden die Elemente neu aufgebaut und ggf. neu nummeriert. Das Problem ist, dass ein Element, das sich auf ein anderes Element bezieht, nach dem Umnummerieren seinen Bezug verlieren kann.

Das heißt: Wenn man eine Skizze auf Fläche7 oder eine Fase auf Ecke8 legt, und danach in dem 3D-Modell auch nur ein einziges Maß ändert, muss man damit rechnen, dass die Skizze und die Fase nicht mehr wissen, wo sie hingehören. Für meinen Geschmack wird da viel Potential und engagierte Entwicklerarbeit verschenkt.

Lösungsansätze:

  • Ich entsage den Freuden des parametrischen Konstruierens und lege keine Skizzen auf Flächen des bisherigen Modells und projiziere keine Geometrien usw. Stattdessen verwende ich Arbeitsebenen uä. und verankere alles im Koordinatensystem, auch wenn das einen Griff zum Taschenrechner erfordert.
  • Für Fasen, Radien usw. siehe auf dieser Seite unter Radien und Fasen bei konstruktiven Elementen
  • Auf die technische Zeichnung eines 3D-Modells soll das topologische Benennungsproblem auch durchschlagen, aber damit habe ich noch keine Erfahrung.

Weitere Infos

Instabile Skizzen [Flipping Sketch]

Ein weiteres Problem, das mich häufig trifft, sind "instabile" oder "versprungene Skizzen". So nenne ich es, wenn sich auch vollständig bestimmte Skizzen ändern, weil FreeCAD neue und völlig überraschende Interpretationen der Abhängigkeiten gefunden hat. Auch dieses Problem macht viel Arbeit, vor allem, weil eine versprungene Skizze nicht einfach rückgängig gemacht werden kann, sondern neu gezeichnet werden muss.
Beispiele:

Sechseck nach dem Umspringen
Sechseck nach dem Umspringen
(eine der Seiten des Quadrates ist dreifach)
Sechseck wie gezeichnet
Sechseck wie gewünscht
  • Beispiel 1: Instabiles_Sechseck.FCStd
    Dieses Bauteil enthält einen sechskantigen Durchbruch [subtraktive Extrusion, Tasche, Pocket] in einer quadratischen Platte [additive Extrusion, Aufpolsterung, Pad], erstellt im Arbeitsbereich PartDesign. Das Sechseck in Sketch001 ist mit der Polygon-Funktion des Sketcher gezeichnet und vollständig bestimmt (alle Seiten gleich lang, eine Kante senkrecht, alle Ecken Punkt auf Objekt mit dem Umkreis, Mittelpunkt des Umkreis zum Koordinatennullpunkt bemaßt).
    Problem: Wenn man die Mittelpunktsmaße ein paar Mal ändert, verspringt das Sechseck früher oder später.
    Probieren Sie es: Das Bauteil ist parametrisch bemaßt, sie müssen nur das Spreadsheet öffnen und ein bisschen mit Maßen x0 und y0 in den Zellen B5 und C5 spielen. Irgendwann wird aus dem Sechseck ein Quadrat mit 3 Linien übereinander oder irgendeine andere mathematisch korrekte, aber praktisch unbrauchbare Interpretation eines regelmäßigen Sechsecks.

    Nachtrag: Mittlerweile ändere ich die Sechsecke aus der Polygon-Funktion des Sketcher sofort nach dem Einfügen und ersetze die letzen drei gleich-lang-Einschränkungen durch 120°-Winkel. Diese Definition des Sechseckes scheint eindeutig zu sein, jedenfalls hatte ich seither keine Probleme mehr mit versprungenen Sechsecken.
    Schade ist, dass FreeCAD nicht gleich die eindeutige Definition anbietet.
Skizze wie gezeichnet
Skizze wie gezeichnet
Skizze nach dem Umspringen
Skizze nach dem Umspringen
  • Beispiel 2: Rand
    Die beiden Screenshots zeigen eine Skizze vor und nach dem Umspringen mit Veränderungen am oberen und unteren Ende.
  • Beispiel 3 (ohne Bild): Nach einer Konstruktionsänderung sind eine Gerade und ein Kreis zwar noch tangential verbunden, bilden aber keinen fließenden Übergang mehr, sondern einen spitzen Winkel.

Positionierungsprobleme durch Rundung

Das Problem "Rundungsabweichungen", wie ich es nenne, betrifft nicht Berechnungen, sondern die Anordnung von geometrischen Elementen. Diese Anordnung basiert auf Zahlen, die natürlich irgendwo gerundet werden müssen, und wenn es an der 13ten Stelle hinter dem Komma ist. Auch Zahlen wie 10, die im Dezimalsystem "glatt" sind, können davon betroffen sein, weil sie computerintern im Binärsystem verrechnet werden.

Das Problem ist, dass 2*5 und 5+5 computerintern vielleicht "10,0000…" oder "9,9999…" ergeben können. Nach außen wird das auf "10" gerundet und alles sieht gut aus. Aber FreeCAD rechnet scheinbar mit den Rohwerten, und wenn ein Klotz "9,9999…"mm entfernt vom Ursprung endet und der andere Klotz "erst" bei "10,0000…"mm beginnt, dann berühren sich die Klötze aus der Sicht von FreeCAD nicht und schon drohen die Fehlermeldungen wie "Error; result is not a solid" oder "result has multiple solid" - Arbeitsbeschaffung wegen eines Muggeseggelis :-(

Inzwischen addiere bzw. subtrahiere ich in Verdachtsfällen schon von vornherein 0,001 mm zu entsprechenden Maßen, um eine Berührung durch Überlappung zu erzwingen. Das kostet natürlich jedesmal Zeit, deshalb wäre es schön, wenn FreeCAD-Algorithmen etwas toleranter ggü. kleinen Abweichungen wären. Gehen muss es, denn von anderen CAD-Programmen kenne ich das Problem nicht.

Hinweis: Die Fehlermeldung Result has multiple solids: that is currently not supported. mit anschließender Arbeitsverweigerung kann auch andere Ursachen haben. Bei der Fliegenklatsche trat sie auf, als ich den Stiel durch Extrusion des Raststeckers erweitern wollte. Zunächst nahm ich das o.g. Problem an und sorgte für die Überlappung, aber die Fehlermeldung blieb bestehen

Doppelt aufgebaute Volumen

Aktualisierung: Ab etwa FC0.21 habe ich das Problem nicht mehr beobachtet. Trotzdem lasse ich den Text stehen, denn falls das Problem nicht völlig verschwunden ist, ist er ein Hinweis, wo man nach Fehlern suchen kann. Auf jeden Fall danke ich den Programmierern für jede Verbesserung, ganz besonders, wenn sie vordergründig unsichtbar ist ;-)

Doppelt aufgebaute Volumen entstehen zum Beispiel, wenn man Formen teilweise auf sich selbst spiegelt oder sich Pfade [Leitlinie, Leitkurve, Path] bei Sweepen [Rohr, Additive Pipe] überschneiden. Gelegentlich trat das Problem erst bei einem späteren Arbeitsschritt auf, sodass ich die Ursache zunächst nicht im doppelten Volumen suchte, obwohl im Nachhinein betrachtet, die Fehlermeldung recht hatt: Result has multiple solids: that is currently not supported.

Wenn FreeCAD einen Fehler meldet, müssen Sie immer damit rechnen, dass das eigentliche Problem nicht im aktuellen Schritt, sondern schon weit vorher aufgetreten ist.

Aus diesem Fall habe ich eine Erkenntnis gezogen:

Inkonsistente Werte und Einfrieren

Screenshot Tabelle und Skizze
Abb.23a Tabelle und Skizze

In Abb.23a ist eine Tabelle mit Parametern dargestellt, die in der Skizze darüber verwendet werden (→ Download der Datei).

Wenn man einen der Parameter Length oder Witdh zu genau 20 mm eingibt, gibt es natürlich eine Fehlermeldung - das alleine wäre i.O.

Oft ist es aber so, dass bei solchen inkonsistenen Werten die Skizze "einfriert" (→ Abb.23b). "Einfrieren" heißt: Es genügt nicht, einfach die Eingabe zu korrigieren oder zurückzunehmen, sondern die betroffenen Skizzen wollen partout neu gezeichnet werden - jedenfalls habe ich noch keine andere nachträgliche Lösung gefunden. Die "Überflüssigen Randbedingungen" zu entfernen läuft letztendlich darauf hinaus, dass die senkrechten Linien verschwinden und die Skizze ruiniert ist.

Vorbeugend hilft es, wenn man inkonsistente Werte schon in der Tabelle ausschließt. Für den Radius in Zelle C4 könnte die Formel lauten:
C4: =min(B4 * 1 mm; Lenght/2 - 0,001 mm; Width/2 - 0,001 mm).
Aber das ist eine Menge Arbeit, besonders in komplexen Modellen …

Bleibt noch die uralte Basis-Methode: Datensicherung, möglichst alle 10 Sekunden. Das hilft auch bei den anderen FreeCAD-Problemen …

Screenshot Tabelle und Skizze
Abb.23b "Eingefrorene" Skizze

Und sage niemand, man müsse eben bei der Eingabe aufpassen: Wer sich von euch noch nie vertippt hat, der werfe den ersten Stein!

Fehlermeldungen in FreeCAD

Skizze wie gezeichnet
Ein ganz fürchterlicher Fehler

AB PartDesign: Ein ganz fürchterlicher, schwerwiegender Fehler ist beim Erstellen der Schräge aufgetreten

  • Status: ungelöst
  • Auftreten: Beim Versuch, eine Fase [Chamfer] durch subtraktives Sweeping [Rohr, Tube] zu ersetzen.
  • Lösung: Humor oder Hilflosigkeit?
    Ich versuche jedenfalls eine Funktion von FreeCAD zu finden, die auch funktioniert.

AB Sketcher: Invalid solution from DogLeg solver

  • Status: ungelöst
  • Auftreten: In einer Skizze, die ich zum Test von regelmäßigen Polygonen erstellt habe.
    • Download: Polygontester.FCStd
    • Zweck der Datei: Durch Änderung eines Winkels (Spreadsheet C2) rotieren die Polygone in Sketch um den Ursprung herum. Getestet werden soll, ob die Polygone bei der Positionsänderungen ihre Form beibehalten oder ob sie instabil sind (Details:  → Instabile Skizzen
    • Auslösen der Fehlermeldung: Änderung des Winkels in C2. Der Fehler tritt nicht immer auf, vor allem bei größeren Änderungen des Winkels wie von 200° auf -45° und ist unabhängig davon, ob ein Polygon instabil kollabiert oder nicht.
  • Recherche:
    • Der Suchbegriff "dogleg solver" ist ziemlich trennscharf
    • Der DogLeg Solver ist ein Algorithmus oder Programm, der oder das nicht nur in FreeCAD zur Lösung von nichtlinearen Gleichungssystemen verwendet wird.
    • Innerhalb FreeCAD.org wird der DogLeg Solver diskutiert wegen gelegentlichen Fehlermeldungen wegen mathematisch und technisch richtigen und sinnvollen Parametern, z.B. Länge = 0 für eine Linie.

Eingabefehler: Failed to validate broken face

  • Status: gelöst
  • Fehlermöglichkeit: Die Skizze, der extrudiert, rotiert .. werden soll, enthält keinen geschlossenen Linienzug.
  • Fehlermöglichkeit: Der geschlossene Linienzug enthält Konstruktionslinien
  • Hilfsmittel zur Analyse von Skizzen: Sketcher - Skizze überprüfen

Formel Editor: Ergebnis: Failed to parse expression

  • Status: gelöst
  • Auftreten: Beim Versuch, ein Maß durch einen Parameter zu ersetzen.
  • Fehlermöglichkeit: Die Fehlermeldung erscheint, bis FreeCAD die Formel lesen kann.
  • Fehlermöglichkeit: Die Formel im Formeleditor begann mit einem Gleichheitszeichen

Meldung über die Transformation: 18 Transformationen überschneiden die Basis nicht
Transformation failed


Fehlermeldung
  • Status: gelöst
  • Die Fehlermeldung tritt auf beim Versuch, ein Sechseck ohne Zusammenhang zu transformieren.
  • Fehlerursache: Vermutlich hängt es mit der Manie von FreeCAD zusammen, dass Volumen zusammenhängend sein müssen.
  • Lösung: Ich habe die Sechsecke auf ein 'Blech' (flaches Pad) gesetzt, das ich am Ende der Konstruktion per SubtractivePad wieder entferne.

Problemlösung

Error: result ist not a solid

  • Befehl: Sweeping und Helix
    Der Fehler ist aufgetreten beim Versuch, ein Gewindeprofil auf einen Bolzen zu schneiden.
  • Fehlerursache: Unklar - Gewinde sind mir früher mit Sweeping und Helix nie gelungen, ab FreeCAD 0.21 habe ich das Problem nicht mehr.
  • Details und Lösungsversuche findet man im guten FreeCAD Tutorium: Gewinde für Schrauben.

Eingabefehler: Unsupported sub-shape type

 

Pad: result has multiple solid

  • Wann trat der Fehler auf?
    Billard-Dreieck: Skizze auf eine vorhandene Fläche kann nicht aufgepolstert werden.
  • Hintergrund:
    Im Arbeitsbereich PartDesign gibt es die Regel, dass in einem Body nicht zwei getrennte Volumen auftreten dürfen. Leider gilt dies auch für Volumen, die durch Rundungsabweichungen um 0,00…01 mm getrennt sind ( → Positionierungsprobleme durch Rundung).
  • Lösung:
    Ich habe die Skizze so gelegt, dass sich die Teilvolumen nicht nur berührten, sondern um den Bruchteil eines mm überschnitten.

Result has multiple solids: that is currently not supported.

Auftreten: Die Fehlermeldung mit anschließender Arbeitsverweigerung trat bei der Fliegenklatsche auf, als ich den Stiel durch Extrusion des Raststeckers erweitern wollte.

Zunächst nahm ich an, dass sich die beiden Teile wegen Rundungsabweichungen nicht berührten , und sorgte für Überlappung der beiden Teile, aber die Fehlermeldung blieb bestehen

Dann führte mich ein anderer Verdacht zum Erfolg: Den Stiel hatte ich nur zur Hälfte modelliert und danach gespiegelt, zum Teil auf sich selbst. Und ausgerechnet an der Stelle, wo der Stiel auf sich selbst gespiegelt war, sollte die Extrusion des Raststeckers anbinden - und das scheint FreeCAD nicht zu mögen.

Lösung: Ich verschob die Spiegelung des Stieles hinter die Extrusion des Raststeckers und es funktioniert - mal sehen, wie lange.

Eingabefehler ToposDS::Face

 

Eingabefehler TopoDS_Buider::Add (sic!)

  • Fehler tritt auf bei Fase [Chamfer]
    Ich hatte ein Element mit Fasen nachträglich vereinfacht, sodass einige Fasen wegfielen. Das merkt FreeCAD offensichtlich nicht von alleine und zeigt sogar die alte Form an, wenn man doppelklickt auf Combo-Ansicht - Aufgaben - Fillet parameters - Edge123.
  • Suchmaschinenanfrage "freecad TopoDS_Buider::Add" = erfolglos
  • Combo-Ansicht - Modell - RMK: Fillet - Objekt neu berechnen = erfolglos
  • Alle Kanten [Edge] löschen in: Combo-Ansicht - Aufgaben - Fillet parameters - Edge…
    und neu vergeben.
  • Bewertung: Nicht befriedigend

Eingabefehler Index out of bound

Sketcher::SketchObject / Sketchxxx: Links go out of the allowed scope

Combo-Ansicht - Skizzennummer

Wo findet man die Nummer der Skizze (sketchxxx)?

  • Die Fehlermeldung erscheint in Ansicht - Panele - Ausgabefenster .
  • xxx steht für die Nummer der Skizze. Wenn man die Skizze umbenannt hat, erfährt man ihre Nummer in den Eigenschaften des übergeordneten Elements: Combo-Ansicht - Modell - Element - Eigenschaft: Sketch Based - Profile - Wert: Sketchxxx
  • Lösung: Die Skizze wurde nicht verwendet und gelöscht, die Fehlermeldung trat nicht mehr auf.

Maßliche Einschränkung - Invalid property specification

  • Die Fehlermeldung erscheint, als im Teil Kasten in der Skizze des Pfades das Maß für die Rundung der äußeren Kante ersetze. R5 statt R6 ergibt noch keine Fehlermeldung, erst später entdecke ich eine Warnung bei einem nachgeordneten Rdaius [Fillet]. Als ich R5 durch ebenfalls den Wert 5mm aus dem eingebetteten Spreadsheet ersetze, erfolgt die Fehlermeldung.
  • freecad "invalid property specification" ergibt in Suchmaschinen einige Links auf Programmcode - nützt mir nix.
  • Fehlersuche: Die Warnung der nachgeordneten Rundung [Fillet] verschwindet, nachdem ich den Radius dieser Rundung verringert habe. Am o.g. Fehler ändert sich nichts.
  • Fehlersuche: Deutliche Vergrößerung des Radius im Spreadsheet auf 10 mm  → keine Änderung.
  • Fehlersuche: Neuer Parameter mit anderem Namen im Spreadsheet auf 10 mm  → keine Änderung.
  • Maßnahme: Ich bleibe bei R6 ohne Parameter aus dem Spreadsheet.

Notizen